-- Protsent kõikide päringute mahust
SELECT  substring(query, 1, 50) AS short_query, 
round(total_time::numeric, 2) AS total_time, 
calls, round((total_time / calls)::numeric, 2) AS mean, 
round((100 * total_time / sum(total_time::numeric) 
OVER ())::numeric, 2) AS percentage_overall
FROM    pg_stat_statements
ORDER BY total_time DESC
LIMIT 20;

-- Protsent päringust mis on IO
SELECT  substring(query, 1, 50) AS short_query, 
round(total_time::numeric, 2) AS total_time, 
calls, round((total_time / calls)::numeric, 2) AS mean, 
round((blk_read_time / total_time * 100)::numeric, 2) AS perc_io
FROM    pg_stat_statements
ORDER BY total_time DESC
LIMIT 20;

-- Tabelite suurused
SELECT relname, pg_size_pretty(pg_total_relation_size(relid)) FROM pg_stat_user_tables;

-- Bgwriter statistika reset
SELECT pg_stat_reset_shared('bgwriter');

-- Bloat statistika
CREATE EXTENSION pgstattuple;
-- tabeli kohta
SELECT * FROM pgstatindex('pgbench_accounts');
-- indexi kohta
SELECT * FROM pgstatindex('pgbench_accounts_pkey');

-- Bloat estimation query
https://github.com/pgexperts/pgx_scripts/blob/master/bloat/

-- Setting up perf
yum install perf # Install perf
# Enable profiling
sudo sysctl kernel.perf_event_paranoid=-­1
sudo sysctl kernel.kptr_restrict=0
# Make profiling survive reboot
sudo tee /etc/sysctl.d/60­perf.conf <<EOF
kernel.kptr_restrict=0
kernel.perf_event_paranoid=-­1
EOF
debuginfo-install postgresql94 # Install debugging symbols

-- buffercache analyys
SELECT c.relname, COUNT(*) AS num FROM pg_buffercache bc, pg_class c 
WHERE c.relfilenode = bc.relfilenode GROUP BY relname ORDER BY num DESC LIMIT 10;

-- random andmed
CREATE TABLE t_test AS SELECT (random()*1000000)::int x, repeat('sadf ',20) FROM generate_series(1,10000000) y;

CREATE INDEX ON t_test (x);

explain (analyze, buffers) SELECT COUNT(*) FROM t_test WHERE x BETWEEN 1 AND 1000;


                                                              QUERY PLAN                                                               
---------------------------------------------------------------------------------------------------------------------------------------
 Aggregate  (cost=110684.15..110684.16 rows=1 width=0) (actual time=8120.298..8120.298 rows=1 loops=1)
   Buffers: shared hit=113 read=9582
   I/O Timings: read=7943.283
   ->  Bitmap Heap Scan on t_test  (cost=1064.93..110559.15 rows=50000 width=0) (actual time=23.149..8112.834 rows=9942 loops=1)
         Recheck Cond: ((x >= 1) AND (x <= 1000))
         Heap Blocks: exact=9665
         Buffers: shared hit=113 read=9582
         I/O Timings: read=7943.283
         ->  Bitmap Index Scan on t_test_x_idx  (cost=0.00..1052.43 rows=50000 width=0) (actual time=15.961..15.961 rows=9942 loops=1)
               Index Cond: ((x >= 1) AND (x <= 1000))
               Buffers: shared read=30
               I/O Timings: read=14.205
 Planning time: 0.519 ms
 Execution time: 8120.391 ms
(14 rows)

CREATE TABLE t_ordered AS SELECT * FROM t_test ORDER BY x;

-- Shared lib'id, mis baasis aktiivsed on
SELECT DISTINCT probin FROM pg_proc ORDER BY probin;

-- Abiks päringuid
https://github.com/pgexperts/pgx_scripts